/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F18857
        Driver Version    :  2.00
 
  74HC595 - PIC: 
    A_SI(U2) - RB7
    A_SCK(U2) - RB6 
    A_RCK(U2) - RB5 
    C_SI(U3/U4) - RB4 
    C_SCK(U3/U4) - RB3
    C_RCK(U3/U4) - RB2 
    G_Red(U3/U4) - RB1 
    G_Grn(U3/U4) - RB0 
 
  74HC595 - Matrix_LED(LTP-12188M-08): 
    U2(Anode)
        QA - A_8(#12) 
        QB - A_7(#9)
        QC - A_6(#6)
        QD - A_5(#3)
        QE - A_4(#13)
        QF - A_3(#16)
        QG - A_2(#19)
        QH - A_1(#22)
 
    U3(Cathode_Red) 
        QA - C_8(#11) 
        QB - C_7(#8)
        QC - C_6(#5)
        QD - C_5(#2)
        QE - C_4(#14)
        QF - C_3(#17)
        QG - C_2(#20)
        QH - C_1(#23)
 
    U4(Cathode_Green) 
        QA - C_8(#10) 
        QB - C_7(#7)
        QC - C_6(#4)
        QD - C_5(#1)
        QE - C_4(#15)
        QF - C_3(#18)
        QG - C_2(#21)
        QH - C_1(#24)

  PIC peripherals:
    RC1 - RTC8564_SCL1 
    RC2 - RTC8564_SDA1  
    RC3 - 10k VR    

    RA0 - [^[GR[_(B) 
    RA1 - ݒXe[^X\LED1
    RA2 - [^[GR[_(A) 
    RA3 - vbVXCb`([hؑ)
    RA4 - vbVXCb`(ݒXe[^X) 
    RA5 - ݒXe[^X\LED2
    RA7 - RTC8564_CLKOUT
 
  
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <string.h>     // memmove֐gp
#include "i2c-lib.h"

// LN^[
__EEPROM_DATA(0x00,0x3E,0x41,0x41,0x41,0x3E,0x00,0x00);     // 0
__EEPROM_DATA(0x00,0x00,0x21,0x7F,0x01,0x00,0x00,0x00);     // 1
__EEPROM_DATA(0x00,0x21,0x43,0x45,0x49,0x31,0x00,0x00);     // 2
__EEPROM_DATA(0x00,0x42,0x41,0x51,0x69,0x46,0x00,0x00);     // 3
__EEPROM_DATA(0x00,0x0C,0x14,0x24,0x7F,0x04,0x00,0x00);     // 4
__EEPROM_DATA(0x00,0x72,0x51,0x51,0x51,0x4E,0x00,0x00);     // 5
__EEPROM_DATA(0x00,0x1E,0x29,0x49,0x49,0x06,0x00,0x00);     // 6
__EEPROM_DATA(0x00,0x40,0x47,0x48,0x50,0x60,0x00,0x00);     // 7
__EEPROM_DATA(0x00,0x36,0x49,0x49,0x49,0x36,0x00,0x00);     // 8
__EEPROM_DATA(0x00,0x30,0x49,0x49,0x4A,0x3C,0x00,0x00);     // 9
//__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);

#define RTC8564_ADDR 0xA2       // RTC8564X[uAhX`:0b1010001(0x51)+0 = 0b10100010 = 0xA2

// Pin̒`t(TC74HC595 - PIC)
#define A_SI RB7    // SI(Am[h) - RB7
#define A_SCK RB6   // SCK(Am[h) - RB6 
#define A_RCK RB5   // RCK(Am[h) - RB5 
#define C_SI RB4    // SI(J\[h) - RB4 
#define C_SCK RB3   // SCK(J\[h) - RB3
#define C_RCK RB2   // RCK(J\[h) - RB2 
#define G_Red RB1   // /G(Red) - RB1 
#define G_Grn RB0   // /G(Green) - RB0 

#define RE_A RA2    // [^[GR[_(A)
#define RE_B RA0    // [^[GR[_(B)
#define SW1 RA3     // [hؑփXCb`
#define SW2 RA4     // ݒXe[^XIXCb`
#define LED1 RA1    // ݒXe[^X\LED1
#define LED2 RA5    // ݒXe[^X\LED2

// O[oϐ錾
unsigned int Table[8];      // \pobt@
unsigned int Hour10[8];     // (10̈)obt@
unsigned int Hour01[8];     // (1̈)obt@
unsigned int Minu10[8];     // (10̈)obt@
unsigned int Minu01[8];     // (1̈)obt@ 

unsigned long Sec,Minu,Hour;    // ϐ
unsigned long H10,H01,M10,M01;  // ݒϐ

unsigned long Adrs;         // AhXϐ
unsigned long StartAdrs;    // f[^ǂݏoJnAhX 
unsigned long EndAdrs;      // f[^ǂݏoIAhX

unsigned long RedStart = 0;     // ԐF\JnAhX 0
unsigned long RedEnd = 23;      // ԐF\IAhX 23
unsigned long GreenStart = 34;   // ΐF\JnAhX 33    
unsigned long GreenEnd = 47;     // ΐF\IAhX 47

unsigned int Flag;          // ԃZbg؂ւptO
unsigned int State;         // ݒ؂ւtO
unsigned long RECount;      // [^[GR[_JEgl

unsigned int Index;         // EEPROMAhXCfbNX
unsigned long eepadrs;      // EEPROMǂݏoAhX

unsigned int *pt;       // \Fp|C^

unsigned int Array[] = {
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,    //  Hour10(10̈)ubN (0-7)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,    //  Hour01(1̈)ubN (8-15)
0x00,0x00,0x00,0x00,0x22,0x00,0x00,0x00,    // : (16-23)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,    //  Minu10(10̈)ubN (24-31)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,    //  Minu01(1̈)ubN (32-39)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};    //  (40-47)
//0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

// vg^Cv錾
void Disp(void);        // \֐
void Shift(void);       // Vtg֐
void TimeSet(void);     // ݒ֐
void DispTime(void);    // ݒ莞\֐
void H10Set(void);      // (10̈)ݒ֐
void H01Set(void);      // (1̈)ݒ֐
void M10Set(void);      // (10̈)ݒ֐
void M01Set(void);      // (1̈)ݒ֐
void RTC8564_INIT(void);    // RTC֐
void Number(void);      // EEPROMǂݏoAhXw֐
int RE(void);       // [^[GR[__GR[h֐

/*
                         Main application
 */

void main(void)
{
    // initialize the device
    SYSTEM_Initialize();
 
    __delay_ms(1000);           // UqUJn҂:1sec(RTCO)    

    // foCX
    RTC8564_INIT();             // RTC(荞݋O)        
    
    // ϐ    
    Sec = 0;
    Minu = 0;
    Hour = 0;              
    Flag = 0;    
    
    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();          // O[o荞݋

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();      // ӊ荞݋

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    while (1)
    {
        // Add your application code

        if(Flag == 0) {         // \[h  

            StartAdrs = 0;      // f[^ǂݏoJnAhXw
            EndAdrs = 48;       // f[^ǂݏoIAhXw
            
            TimeSet();      // ݒ֐Ăяo
            Shift();        // Vtg֐Ăяo         
            
            if(SW1 == 0) {      // ݒ胂[h SW1I            

                LATA = 0b00100010;      // [^[GR[_LED(+)_
                Flag = 1;               // ݒ胂[h                
                GIE = 0;                // O[o荞݋֎~
                State = 0xFF;           // StateZbg

                H10 = 0;        // (10̈)Zbg
                H01 = 0;        // (1̈)Zbg
                M10 = 0;        // (10̈)Zbg
                M01 = 0;        // (1̈)Zbg
                
                while (SW1 == 0)        // `^O        
                __delay_ms(25);                   
            }        
        }

        else {                      // Flag0(ݒ胂[h)
            if(SW2 == 0) {                  // I SW2I            
                State++;                    // StateJEgAbv                    
                
                if (State > 4)              // State > 2Ȃ       
                    State = 0;              // StateZbg                

                while (SW2 == 0)            // `^O        
                __delay_ms(25);                                       
            }
                
            switch(State) {         // State
                case 0:         // (10̈)
                    LATA = 0b00100000;      // [^[GR[_LED()_
                    RECount = 0;        // RECountZbg

                    while (State == 0)
                    {
                        RECount += RE();        // [^[GR[_JEg(4{l)
                        H10 = RECount / 4;      // 1{lɊZĕϐH10ɑ                        

                        if (H10 > 2) {        // H10>2Ȃ
                            H10 = 0;           // H10Zbg
                            RECount = 0;      // RECountZbg
                        }                        

                        if (H10 == 0)          // H100Ȃ                        
                            H10 = 0;           // H10Zbg

                        TimeSet();      // ݒ֐Ăяo
                        H10Set();       // (10̈)ݒ֐Ăяo                        
                        
                        if(SW2 == 0)
                            break;
                    }
                    break;

                case 1:         // (1̈)                
                    LATA = 0b00100000;      // [^[GR[_LED()_
                    RECount = 0;        // RECountZbg

                    while (State == 1)
                    {
                        RECount += RE();        // [^[GR[_JEg(4{l)
                        H01 = RECount / 4;      // 1{lɊZĕϐH01ɑ                        

                        if (H10 == 2) {         // (10̈)=2̏ꍇ
                            if (H01 > 3) {          // H01>3Ȃ (23܂)
                                H01 = 0;            // H01Zbg
                                RECount = 0;        // RECountZbg
                            }
                        }                                  
                        
                        if (H01 > 9) {          // H01>9Ȃ
                            H01 = 0;            // H01Zbg
                            RECount = 0;        // RECountZbg
                        }                        

                        if (H01 == 0)       // H010Ȃ                        
                            H01 = 0;        // H01Zbg

                        TimeSet();      // ݒ֐Ăяo
                        H01Set();       // (1̈)ݒ֐Ăяo   
                        
                        if(SW2 == 0)
                            break;
                    }
                    break;

                case 2:         // (10̈)
                    LATA = 0b00000010;      // [^[GR[_LED()_
                    RECount = 0;        // RECountZbg

                    while (State == 2)
                    {
                        RECount += RE();        // [^[GR[_JEg(4{l)
                        M10 = RECount / 4;      // 1{lɊZĕϐM10ɑ                        

                        if (M10 > 5) {          // M10>5Ȃ
                            M10 = 0;            // M10Zbg
                            RECount = 0;        // RECountZbg
                        }                        

                        if (M10 == 0)       // M100Ȃ                        
                            M10 = 0;        // M10Zbg

                        TimeSet();      // ݒ֐Ăяo
                        M10Set();       // (10̈)ݒ֐Ăяo 
                        
                        if(SW2 == 0)
                            break;
                    }
                    break;

                case 3:         // (1̈)                
                    LATA = 0b00000010;      // [^[GR[_LED()_
                    RECount = 0;        // RECountZbg

                    while (State == 3)
                    {
                        RECount += RE();        // [^[GR[_JEg(4{l)
                        M01 = RECount / 4;      // 1{lɊZĕϐM01ɑ                        

                        if (M01 > 9) {          // M01>9Ȃ
                            M01 = 0;            // M01Zbg
                            RECount = 0;        // RECountZbg
                        }

                        if (M01 == 0)       // M010Ȃ                        
                            M01 = 0;        // M01Zbg

                        TimeSet();      // ݒ֐Ăяo
                        M01Set();       // (1̈)ݒ֐Ăяo 
                        
                        if(SW2 == 0)
                            break;
                    }
                    break;                    
                   
                case 4:                    
                    LATA = 0b00100010;      // [^[GR[_LED(+)_
                    
                    if(SW1 == 0) {          // SW1(ԃZbg)I            
                        Sec = 0;            // bZbg
                        Flag = 0;           // FlagZbg
                        GIE = 1;            // O[o荞݋

                        Hour = H10 * 10 + H01;    // Hour   
                        Minu = M10 * 10 + M01;    // Minu   
                    
                        while (SW1 == 0)    // `^O        
                        __delay_ms(25);                            

                        LATA = 0;          // [^[GR[_LED
                    }
                    break;
                                
                default:break;
            }                                
        }
    }
}

// ݒ֐
void TimeSet(void) {

    unsigned int i;    
    
// EEPROMLN^[obt@ɃRs[    
// (10̈)
    if(Flag == 0)
        Index = Hour / 10;      // (10̈):\
    else    
        Index = H10;      // (10̈):ݒ    
    
    Number();      // EEPROMǂݏoAhXw
    for (i=0; i<8; i++) {
        Hour10[i] = eeprom_read(eepadrs);   // EEPROM10̈ʂ̃LHour10ɃRs[
        eepadrs++;
    }

// (1̈)    
    if(Flag == 0)    
        Index = Hour % 10;      // (1̈):\
    else    
        Index = H01;      // (1̈):ݒ

    Number();      // EEPROMǂݏoAhXw
    for (i=0; i<8; i++) {
        Hour01[i] = eeprom_read(eepadrs);   // EEPROM1̈ʂ̃LHour01ɃRs[
        eepadrs++;
    }    

// (10̈)    
    if(Flag == 0)    
        Index = Minu / 10;      // (10̈):\
    else    
        Index = M10;      // (10̈):ݒ

    Number();      // EEPROMǂݏoAhXw
    for (i=0; i<8; i++) {
        Minu10[i] = eeprom_read(eepadrs);   // EEPROM10̈ʂ̃LMinu10ɃRs[
        eepadrs++;
    }

// (1̌)    
    if(Flag == 0)    
        Index = Minu % 10;      // (1̌):\
    else    
        Index = M01;      // (1̈):ݒ

    Number();      // EEPROMǂݏoAhXw
    for (i=0; i<8; i++) {
        Minu01[i] = eeprom_read(eepadrs);   // EEPROM1̈ʂ̃LMinu01ɃRs[
        eepadrs++;
    }
}

void Shift(void)     // Vtg֐
{
    unsigned int i;        
  
    while (1)
    {
// zobt@ArrayɃRs[
        memmove(Array,Hour10,8);        // Array̐擪ԒnHour108 byteRs[
        memmove(Array+8,Hour01,8);      // Array̐擪Ԓn+8 byteڂHour018 byteRs[
        memmove(Array+24,Minu10,8);     // Array̐擪Ԓn+24 byteڂMinu108 byteRs[
        memmove(Array+32,Minu01,8);     // Array̐擪Ԓn+32 byteڂMinu018 byteRs[
        
        Adrs = StartAdrs;   // Adrsϐ
        
        for(i=0; i<8; i++) {
            Table[i] = Array[Adrs];   // ArrayTableɃRs[            
            Adrs++;     // AdrsCNg
            if (Adrs > EndAdrs)     // Adrs > EndAdrsȂAdrsZbg        
                Adrs = 0;
        }            

        Disp();     // \֐Ăяo        
        
        StartAdrs++;    // StartAdrsCNg
        if (StartAdrs > EndAdrs)    // StartAdrs > EndAdrsȂ烋[v𔲂 
            break;    
    }
}

void Disp(void)     // \֐
{
    unsigned long VADC;     // ADCϊli[p
    unsigned int A_Pos;     // Am[hp
    unsigned int i,j,k,p;     // \pϐ
    
    VADC = ADCC_GetSingleConversion(channel_ANC3);      // ADCϊʂVADCɊi[
    p = VADC / 5;

    for(k=0; k<p; k++) {       // XN[x        

        A_Pos = 0x01;   // Am[hrbgq   
       
        for(i=0; i<8; i++) {

            for(j=0; j<8; j++) {
// J\[hVtgWX^]                
                if (((~(Table[i]) >> j) & 1) == 1)     // Table[i]rbg]ărbg
                    C_SI = 1;            
                else
                    C_SI = 0;

                C_SCK = 1;      // VtgWX^ɃVAM荞            
                C_SCK = 0;

// Am[hVtgWX^]
                if (((A_Pos >> j) & 1) == 1)     // Am[h̃rbg            
                    A_SI = 1;            
                else
                    A_SI = 0;

                A_SCK = 1;      // VtgWX^ɃAm[h荞            
                A_SCK = 0;
            }
            
            A_Pos <<= 1;    // rbgq1rbgVtg            

// 3Xe[gobt@
            pt = &Table[Adrs + (i+1)];      // pt(|C^ϐ)Table[Adrs + (i-1)]̃AhX
            
// ͐ԐF            
            if((pt >= &Table[RedStart]) && (pt <= &Table[RedEnd])) 
                G_Grn = 1;      // 3Xe[gobt@():disable
            
// ͗ΐF            
            else if((pt >= &Table[GreenStart]) && (pt <= &Table[GreenEnd])) 
                G_Red = 1;      // 3Xe[gobt@():disable         

// tH[}bg͞(+)            
            else {
                G_Red = 0;      // 3Xe[gobt@():able
                G_Grn = 0;      // 3Xe[gobt@():able                               
            }
            
            C_RCK = 1;      // Xg[WWX^(J\[h)o            
            C_RCK = 0;           

            A_RCK = 1;      // Xg[WWX^(Am[h)o
            A_RCK = 0;
        }            
    }        
}

void DispTime(void)     // ݒ莞\֐
{
    unsigned int A_Pos;     // Am[hp
    unsigned int i,j,p;     // \pϐ
    
        A_Pos = 0x01;   // Am[hrbgq   
       
        for(i=0; i<8; i++) {

            for(j=0; j<8; j++) {
// J\[hVtgWX^]                
                if (((~(Table[i]) >> j) & 1) == 1)     // Table[i]rbg]ărbg
                    C_SI = 1;            
                else
                    C_SI = 0;

                C_SCK = 1;      // VtgWX^ɃVAM荞            
                C_SCK = 0;

// Am[hVtgWX^]
                if (((A_Pos >> j) & 1) == 1)     // Am[h̃rbg            
                    A_SI = 1;            
                else
                    A_SI = 0;

                A_SCK = 1;      // VtgWX^ɃAm[h荞            
                A_SCK = 0;
            }
            
            A_Pos <<= 1;    // rbgq1rbgVtg            

// ͐ԐF            
            if(State == 0 || State == 1) {
                G_Red = 0;      // 3Xe[gobt@():able                
                G_Grn = 1;      // 3Xe[gobt@():disable
            }            

// ͗ΐF            
            if(State == 2 || State == 3) {
                G_Red = 1;      // 3Xe[gobt@():disable                
                G_Grn = 0;      // 3Xe[gobt@():able
            }
           
            C_RCK = 1;      // Xg[WWX^(J\[h)o            
            C_RCK = 0;           

            A_RCK = 1;      // Xg[WWX^(Am[h)o
            A_RCK = 0;
        }            
}

// (10̈)ݒ֐
void H10Set(void){

    unsigned int i; 
    Adrs = 0;       // AdrsZbg
    
    for(i=0; i<8; i++) {
        Table[i] = Hour10[Adrs];   // Hour10TableɃRs[            
        Adrs++;     // AdrsCNg
        if (Adrs > 8)     // Adrs > 8ȂAdrsZbg        
            Adrs = 0;
    }            

    DispTime();     // ݒ莞\֐Ăяo 
}     

// (1̈)ݒ֐
void H01Set(void){

    unsigned int i; 
    Adrs = 0;       // AdrsZbg
    
    for(i=0; i<8; i++) {
        Table[i] = Hour01[Adrs];   // Hour01TableɃRs[            
        Adrs++;     // AdrsCNg
        if (Adrs > 8)     // Adrs > 8ȂAdrsZbg        
            Adrs = 0;
    }            

    DispTime();     // ݒ莞\֐Ăяo 
} 

// (10̈)ݒ֐
void M10Set(void){

    unsigned int i; 
    Adrs = 0;       // AdrsZbg
    
    for(i=0; i<8; i++) {
        Table[i] = Minu10[Adrs];   // Minu10TableɃRs[            
        Adrs++;     // AdrsCNg
        if (Adrs > 8)     // Adrs > 8ȂAdrsZbg        
            Adrs = 0;
    }            

    DispTime();     // ݒ莞\֐Ăяo
}

// (1̈)ݒ֐
void M01Set(void){

    unsigned int i; 
    Adrs = 0;       // AdrsZbg
    
    for(i=0; i<8; i++) {
        Table[i] = Minu01[Adrs];   // Minu01TableɃRs[            
        Adrs++;     // AdrsCNg
        if (Adrs > 8)     // Adrs > 8ȂAdrsZbg        
            Adrs = 0;
    }            

    DispTime();     // ݒ莞\֐Ăяo
}

// RTC֐
void RTC8564_INIT(void) {

// eWX^ݒ    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(RTC8564_ADDR);    // X[uAhXw

    i2c_send_byte(0x00);            // 擪AhXw(ȉI[gCNg)

    i2c_send_byte(0);               // AhX(0x00):Rg[WX^ 1 ݒ
    i2c_send_byte(0);               // AhX(0x01):Rg[WX^ 2 ݒ
    i2c_send_byte(0);               // AhX(0x02):vJE^ b     
    i2c_send_byte(0);               // AhX(0x03):vJE^          
    i2c_send_byte(0);               // AhX(0x04):vJE^      
    i2c_send_byte(0);               // AhX(0x05):J_[JE^    
    i2c_send_byte(0);               // AhX(0x06):J_[JE^ j     
    i2c_send_byte(0);               // AhX(0x07):J_[JE^         
    i2c_send_byte(0);               // AhX(0x08):J_[JE^ N     
    i2c_send_byte(0x80);            // AhX(0x09):A[   (AErbg=1) 
    i2c_send_byte(0x80);            // AhX(0x0A):A[   (AErbg=1)    
    i2c_send_byte(0x80);            // AhX(0x0B):A[   (AErbg=1)   
    i2c_send_byte(0x80);            // AhX(0x0C):A[ j  (AErbg=1)     
    i2c_send_byte(0x83);            // AhX(0x0D):CLKOUT= 1 Hz AEgvbgݒ (0b10000011)
    i2c_send_byte(0);               // AhX(0x0E):^C}荞ݒ~ (TFrbg=0)        
    i2c_send_byte(0);               // AhX(0x0F):^C} ݒ    
    
    i2c_stop();                     // I2CXgbvRfBVs         
}

// EEPROMǂݏoAhXw֐
void Number(void) {

    switch(Index) {
        case 0:
            eepadrs = 0;    //u0v
            break;

        case 1:
            eepadrs = 8;    //u1v
            break;            
            
        case 2:
            eepadrs = 16;   //u2v
            break;            

        case 3:
            eepadrs = 24;   //u3v 
            break;

        case 4:
            eepadrs = 32;   //u4v
            break;

        case 5:
            eepadrs = 40;   //u5v
            break;

        case 6:
            eepadrs = 48;   //u6v
            break;

        case 7:
            eepadrs = 56;   //u7v
            break;

        case 8:
            eepadrs = 64;   //u8v
            break;

        case 9:
            eepadrs = 72;   //u9v
            break;

        default:
            break;            
    }
}

// [^[GR[__GR[h֐
int RE(void) {
    static const int Dir[] = {0,1,-1,0,-1,0,0,1,1,0,0,-1,0,-1,1,0};     // ]e[u (0:ωȂ, 1:CW, -1:CCW)
    static int Prev;                // Õ[^[GR[_li[ϐ(static^Œlێ)
    unsigned int Curr;              // ݂̃[^[GR[_li[ϐ
    unsigned int i;                 // DirQƗpCfbNX
    Curr = (RE_B << 1) + RE_A;      // ݂̃[^[GR[_Ԃǂݍ <1:0>
    Prev <<= 2;                     // Ol2rbgVtg <3:2> 
    Prev |= (Curr & 0x03);          // Ol2rbg <3:2>ƌݒl2rbg <1:0>
    i = Prev & 0x0F;            // 4rbg <3:0>vCfbNXl
    return (Dir[i]);            // CfbNXDir[]ƍlԂ
}

/**
 End of File
*/
